CON              
                                                           
  _CLKMODE = XTAL1 + PLL16X                              
  _XINFREQ = 5_000_000

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000

  LED_PIN = 17     'prop port for di pin on ws2812's

  TOTAL_LEDS = 6
  MAX_LED_INDEX = TOTAL_LEDS - 1
  COLORS_IN_TABLE = 6
  MAX_COLOR_INDEX = COLORS_IN_TABLE - 1

OBJ

  Leds : "jm_ws2812"
  Pst : "Parallax Serial Terminal"
                   
PUB Main | addr, localIndex
    
  Leds.start(LED_PIN, TOTAL_LEDS)
  Pst.Start(115_200)  

  Leds.set_all(0)
  waitcnt(clkfreq / 4 + cnt)      
  MainLoop
  
PUB MainLoop | ledIndex, tableIndex, firstColorIndex


  ledIndex := 0
  firstColorIndex := 0
  tableIndex := firstColorIndex
  
  repeat
    Leds.set(ledIndex, colorTable[tableIndex])
    ledIndex := AddWithRollover(ledIndex, 1, MAX_LED_INDEX)
    Pst.str(string(13, "ledIndex = "))
    Pst.dec(ledIndex)
    Pst.str(string(", tableIndex = "))
      Pst.dec(tableIndex)  
    if ledIndex == 0 '' Back at the start so use a differnt first color
      firstColorIndex := AddWithRollover(firstColorIndex, 1, MAX_COLOR_INDEX)
      tableIndex := firstColorIndex
      Pst.str(string(", firstColorIndex = "))
      Pst.dec(firstColorIndex)
    else  
      tableIndex := AddWithRollover(tableIndex, 1, MAX_COLOR_INDEX)
    
    waitcnt(clkfreq / 4 + cnt)  

PUB AddWithRollover(presentValue, amountToAdd, maxValue)
'' Assumes all parameters are positive.

  result := presentValue + amountToAdd

  if result > maxValue
    result := 0
 
DAT ' color table
                             ' red       yellow        green                blue
colorTable              long $FF_00_00, $7F_7F_00, $00_FF_00, $00_7F_7F, $00_00_FF, $7F_00_7F
